<?php
defined('BASEPATH') OR exit('No direct script access allowed');

/**
 * User class.
 * 
 * @extends CI_Controller
 */
class Mailing extends CI_Controller {

	/**
	 * __construct function.
	 * 
	 * @access public
	 * @return void
	 */
	public function __construct() {
		
		parent::__construct();
		$this->load->library(array('session'));
		$this->load->helper(array('url'));
		$this->load->model('Emailer_Model','emailer');
	  $this->load->model('Template_Model','TemplateModel',TRUE);
		
	}
 
public function index() {	
//print_r($_SESSION);
}
	

public function create_failed_emails_table(){
	echo $sql="CREATE TABLE IF NOT EXISTS `failed_emails` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `added_time` datetime NOT NULL DEFAULT current_timestamp(),
  `from` varchar(256) CHARACTER SET utf8 NOT NULL,
  `to` varchar(256) CHARACTER SET utf8 NOT NULL,
  `subject` varchar(256) CHARACTER SET utf8 NOT NULL,
  `extra` varchar(512) CHARACTER SET utf8 NOT NULL,
  `information` text CHARACTER SET utf8 NOT NULL,
  `status` int(2) DEFAULT 0,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;";
$this->load->database();
$this->db->query($sql);
$affected_rows = $this->db->affected_rows();
log_data("create_failed_emails_table"," affected_rows $affected_rows sql $sql" , $affected_rows);
}
public function save_failed_mails_detail($from,$to,$subject,$information,$extra){
	$time_now = get_current_actual_dubai_time();
	$data = array(
			'from'   => $from ,
			'to'   => $to,
			'added_time'   => $time_now,
			'subject'   =>$subject,
			'information'   => $information, 
			'extra'   => $extra 
			 ) ;
	 $this->db->insert('failed_emails',$data);
}  
 
public function delete_old_log( ){
	//echo $del_limit_days = 8;
	$del_limit_days =$_REQUEST['days'];
	$token =$_REQUEST['token'];
	
	$this->load->model('Mailing_Model','MailingModel',TRUE);
	
	$this->MailingModel->delete_old_log($token,$del_limit_days);
	
	}
public function delete_log() {
	$month=date("M");
	/*$file = "log/cron_tracker_$month.txt";
	unlink($file);
	echo "$file deleted";
	 */
$token=$this->uri->segment(3);
	
	$sql="delete FROM `logs`";
	
	if($token!='') $sql="delete FROM `logs` where token='$token'";
	echo $sql; 
   $this->db->query($sql);
   $affected_rows = $this->db->affected_rows();
   log_data("delete_log","Deleted count : $affected_rows ".$sql,$affected_rows);
	 
}
 

public function show_log() {
	$session_data = $this->session->userdata;
	if(!isset($session_data['logged_in'] )){
		  echo "<div class='alert alert-danger'>You are not logged in</div>";
		  return false;
	}
	$month=date("M");
	$file = "log/cron_tracker_$month.txt";
	//$content =  file_get_contents($file);
	//$content = nl2br($content);
	$token=$this->uri->segment(3);
	$page_no = $this->uri->segment(4);
	if($page_no=='') $page_no=1;
	$page_size=30;
	$start = ($page_no-1)*$page_size;
	$end= $start+$page_size;
	$limit = " limit $start, $page_size";
	
	$sql="SELECT * FROM `logs` order by id desc";
	if($token!='all' and $token!='') $sql="SELECT * FROM `logs` where token='$token' order by id desc";
	
	$query = $this->db->query($sql);
	$total = $query->num_rows();
	$pagination="<ul class='pagination pagination-sm' style='margin:0px'>";
	$total_page_count = ceil($total/$page_size)+1;
	for($j=1;$j<$total_page_count;$j++){
		if($j==$page_no)
		$pagination .= " <li class='disabled'><a class='page-link' style='background-color:#6c757d;color:#fff;'>$j</a></li>";
	    else $pagination .= " <li style='cursor:pointer' onclick='show_log(\"$token\",$j)'><a class='page-link'>$j</a></li>";
	    
	}
	$pagination .="</ul>";
	
	$sql="SELECT * FROM `logs` order by id desc $limit";
	
	if($token!='') $sql="SELECT * FROM `logs` where token='$token' order by id desc $limit";
	// echo $sql; 
	//log_data("show_log",$sql);
$query = $this->db->query($sql);
$del_btn='';
  if($token !=''){
  $del_btn=" <button type='button' onclick='delete_log(\"$token\")' class='btn btn-warning'>Delete $token</button>";
  $del_btn2=" <button type='button' onclick='delete_old_log(\"$token\",1)' class='btn btn-warning'>Delete $token older than 1 day</button>";
  $del_btn3=" <button type='button' onclick='delete_old_log(\"$token\",7)' class='btn btn-warning'>Delete $token older than 7 days</button>";
  
  }

$content = "<table class='table table-condensed table-bordered table-striped'>";
$i=0;
foreach ($query->result() as $row)
   { $i++;
	 $time = $row->added_time;
	 $token = $row->token;
	 $month = $row->month;
	 $day = $row->day;
	 $information = $row->information;
	 $content .= "<tr><td>$time</td><td>$token</td><td>$information</td><td>$month - $day</td></tr>";
   }
$content .="</table>";	
$buttons="$del_btn &nbsp;&nbsp; $del_btn2 &nbsp;&nbsp; $del_btn3 &nbsp;&nbsp;&nbsp;&nbsp; Showing page no $page_no from total $total records<br><br>";
	
	echo "<div class='well well-lg' style='font-size:12px;color:#777777'>$pagination <br> $buttons $content</div>"; 
}

public function update_country_name(){
$sql="SELECT distinct country FROM `hcp_email_queue` where country_name is null or country_name =''";
$query = $this->db->query($sql);

$row_count = $query->num_rows();
echo "<br>$row_count countries found to update.";
if($row_count>0){

foreach ($query->result() as $row)
   { 
	 $country_id = $row->country;
	 $sql2="SELECT `Country Name` as cname FROM `country` where `Country-ID` =$country_id";
$query = $this->db->query($sql2);
foreach ($query->result() as $row2)
   { 
	 $country_name = $row2->cname;
	 
	  if(strlen( $country_name)>2){
	$update_sql="update `hcp_email_queue` set country_name ='$country_name'  where country='$country_id' and ( country_name is null or country_name ='')"; 
	$this->db->query($update_sql);  
	$affected_rows = $this->db->affected_rows();
	echo "<br>$affected_rows records got updated for $country_name ($country_id).";
    log_data("country_name_update", "$update_sql \r\n Affected rows: $affected_rows \r\n ". __METHOD__ . " Line : " . __LINE__ . "\r\n",$affected_rows);
   }
	 
	 
   }
   
   }
   
   }
}


public function test() {
 $delay_seconds = rand(3,12);
 sleep($delay_seconds);
 echo $time_now = get_current_actual_dubai_time();
 $day = date("d" ,strtotime($time_now));
 $hour = date("G",strtotime($time_now));
 $minute = intval(date("i",strtotime($time_now)));
 $second = date("s",strtotime($time_now)); 
echo "<br>Hour :".$hour ." : ". $minute . "<br>";
if(in_array($day, array(1,8,15,23,29)) and in_array($hour, array(1,5)) and in_array($minute, array(26,53))){
echo "<br>deleting all much old logs line " .__LINE__;
$this->load->model('Mailing_Model','MailingModel',TRUE);
$this->MailingModel->delete_old_log('',45);
echo "<br>deleting all much old logs line " .__LINE__;
 log_data("delete_old_log","deleting all much old logs",45);
}

if(in_array($hour, array(2,4 )) and ($minute%23)==1){
 $this->delete_sent_records();
}
if(in_array($hour, array(3,5,9)) and ($minute%20)==1){
 $this->delete_downloaded_records();
}

$this->update_country_name();
 
	//echo ENVIRONMENT;
	// error_reporting(E_ALL & ~E_NOTICE);
$this->load->helper('helper');	
//$this->load->database();
//file_put_contents("log/test.txt", " <br> dasd $time_now ",FILE_APPEND);
// echo file_get_contents("log/test.txt");
//$file = "log/cron_tracker.txt";
echo  "Logging at  : $minute ";	


 
if($minute%3==0){
	$this->send();
	echo  "Logging at 3 : $minute ";	
//log_data("send_cron", " Calling to send emails  : $delay_seconds seconds  ". __METHOD__ . " Line : " . __LINE__);	 
return false;
}
if($minute%2==0){
	$this->send();
	echo  "Logging at 2 : $minute ";
  //log_data("cron_tracker", " Logging on 2 : $minute delayed : $delay_seconds seconds and returning ". __METHOD__ . " Line : " . __LINE__);	 
return false;
}

  $time_now = get_current_actual_dubai_time();

}	


public function delete_sent_records() {
//return false;	
$today=date("Y-m-d");
$date= date("Y-m-d" , strtotime("-2 days"));			
$sql = "DELETE FROM `hcp_email_queue` where email_send_status =3 and   sent_date < '$date'";
$this->db->query($sql);
$affected_rows = $this->db->affected_rows();
log_data("delete_sent_records","Deleted sent records from email queue count : $affected_rows $sql", $affected_rows);
$this->delete_failed_records();
$this->delete_duplicate_records();
}

public function delete_failed_records() {
//return false;	
$today=date("Y-m-d");
$date= date("Y-m-d" , strtotime("-12 days"));			
$sql = "DELETE FROM `hcp_email_queue` where email_send_status =4 and   sent_date < '$date'";
$this->db->query($sql);
$affected_rows = $this->db->affected_rows();
log_data("delete_failed_records","Deleted failed records from email queue count : $affected_rows $sql", $affected_rows);
}

public function delete_duplicate_records() {
//return false;	
$today=date("Y-m-d");
$date= date("Y-m-d" , strtotime("-7 days"));			
$sql = "DELETE FROM `hcp_email_queue` where email_send_status =9 and   sent_date < '$date'";
$this->db->query($sql);
$affected_rows = $this->db->affected_rows();
log_data("delete_duplicate_records","Deleted duplicate records from email queue count : $affected_rows $sql", $affected_rows);
}

public function delete_downloaded_records() {
//return false;	
$today=date("Y-m-d");	
$date= date("Y-m-d" , strtotime("-2 days"));	
$sql = "DELETE FROM `email_actions` where status=1 and imported_time < '$date'";
$this->db->query($sql);
$affected_rows = $this->db->affected_rows();
log_data("delete_downloaded_records","Deleted rows from email actions count : $affected_rows $sql" , $affected_rows);
}


public function get_failed_email_data() {
$sql = "SELECT * FROM `hcp_email_queue` where email_send_status =4 and subject='Failed to send'  order by jupiter_id limit 0,250";
$query = $this->db->query($sql);
$i=0;
foreach ($query->result() as $row)
   {$i++;
	 $ids[] = $id = $row->id;
	 $hcp_id = $row->hcp_id;
	 $jupiter_id = $row->jupiter_id;
	 $project_id = $row->project_id;
	 $subject = $row->subject; 
	 $data = array();
	 $data['hcp_id'] =$hcp_id;
	 $data['pi'] = $project_id;
	 $data['ji']  = $jupiter_id;
	 $data['s'] =$subject;
	 $all_data[] = $data;
	 $jupiter_ids[] = $jupiter_id;
	 unset($data);
   }
   if($i>0){ 
   
   $all_ids = implode(",",$ids);
   echo $all_jupiter_ids = implode(",",$jupiter_ids);
   //echo "<hr>";
   //echo json_encode($all_data);
   $update_sql="update hcp_email_queue set subject='failed_data_download_done' where id IN($all_ids);";
	// echo "<br><br>". $sql."<br><br>";
	$this->db->query($update_sql);
	$affected_rows = $this->db->affected_rows();
	log_data("failed_email_data","set subject='Failed to send download_done' where id IN($all_ids) affected_rows : $affected_rows",$affected_rows);	 
   }
}

public function get_email_actions() {
$sql = "SELECT * FROM `email_actions` where status is null limit 0,250";
$query = $this->db->query($sql);
$i=0;
foreach ($query->result() as $row)
   {$i++;
	 $ids[] = $id = $row->id;
	 $hcp_id = $row->hcp_id;
	 $project_id = $row->project_id;
	 $template_id = $row->template_id;
	 $password = $row->password;
	 $from_email = $row->from_email;
	 $date = $row->date;
	 $incentive = $row->incentive;
	 $email_assignment_id = $row->email_assignment_id;
	 $data = array();
	 $data['hcp_id'] =$hcp_id;
	 $data['pi'] = $project_id;
	 $data['p']  = $password;
	 $data['fe'] =$from_email;
	 $data['d'] =$date;
	 $data['i'] =$incentive;
	 $data['eid'] =$email_assignment_id;
	 $data['eid'] =$email_assignment_id;
	 $data['t'] =$template_id;
	 $all_data[] = $data;
	 unset($data);
   }
   if($i>0){ echo json_encode($all_data);
   
   $all_ids = implode(",",$ids);
	 $update_sql="update email_actions set status=1	 where id IN($all_ids);";
	 
	// echo "<br><br>". $sql."<br><br>";
	 $this->db->query($update_sql);
	 $affected_rows = $this->db->affected_rows();
	 log_data("get_email_actions","set status=1	 where id IN($all_ids) affected_rows : $affected_rows",$affected_rows);	 
   }
   
}

 

public function get_left_column() {
	$session_data = $this->session->userdata;
	if(!isset($session_data['logged_in'] )){
		  echo "<div class='alert alert-danger'>You are not logged in</div>";
		  return false;
	}
	$this->load->database();
	$sql = "SELECT distinct token FROM `logs` order by token";
 
//echo $sql;
$query = $this->db->query($sql);
$content = "<table class='table borderless'>";
$i=0;
foreach ($query->result() as $row)
   { $i++;
	 $token = trim($row->token);
	  if(strpos($token,".txt")>3){}else{
	  $show_btn=" <button type='button' onclick='show_log(\"$token\",1)' class='btn btn-secondary'>Show $token</button>";
	$content .="<tr class='borderless'><td >$show_btn</td></tr>";  	
	  }
	 
   }
   if($i>0) echo $content .= "</table>";	
	
	
}

public function delete_unwanted_duplicate_block_logs() {
	$del_sql="delete FROM `logs` WHERE `token` = 'duplicate_block'  and information='Total duplicate = 0'";
    $this->db->query($del_sql);	
	$affected_rows = $this->db->affected_rows();
	log_data("delete_duplicate_block_logs", "$affected_rows records deleted" );
	$time_now = get_current_actual_dubai_time();
	$day = date("d" ,strtotime($time_now));
	if($day%5 ==1){
	$this->load->model('Mailing_Model','MailingModel',TRUE);	
	$del_limit_days = 30;	
	$this->MailingModel->delete_old_log($token,$del_limit_days);
	log_data("delete_old_log", "delete_old_log for older than $del_limit_days days" );
	}
}	


public function get_log_count() {
$this->load->helper('helper');	
$this->load->database();
$token =$this->uri->segment(3);
$today= date("Y-m-d"); 
$yesterday= date("Y-m-d", strtotime("yesterday")); 
  $sql = "SELECT token ,count(token) as cnt FROM `logs` where    added_time>'$yesterday' group by token"; // and  added_time<'$today' or email_send_status!=3
$query = $this->db->query($sql);
$count=0;
foreach ($query->result() as $row)
{
	$token = $row->token; 
	$count = $row->cnt; 
	$data[$token] = $count;
}
echo json_encode($data);
}

public function remove_records_from_server() {
$this->load->database();
//echo "project_id".$project_id = $_REQUEST['project_id'];
$project_id =$this->uri->segment(3);
if($project_id>11000){
	$ids = array();
	$sql="select jupiter_id from hcp_email_queue where email_send_status is null and project_id = $project_id";
	$query = $this->db->query($sql);
	foreach ($query->result() as $row)
    {  
    $jupiter_id = trim($row->jupiter_id);
    $ids[] = $jupiter_id;
    }
	$count = count($ids);
	if($count>0){
		echo $all_ids = implode(",",$ids);
	$time_now = get_current_actual_dubai_time();
	log_data("remove_records","all number of records to remove, count $count: all_ids :  $all_ids ",$count);
	$del_sql="delete from hcp_email_queue where email_send_status is null and project_id = $project_id";
	$this->db->query($del_sql);
	$affected_rows = $this->db->affected_rows();
	log_data("remove_records","delete count : $affected_rows ".$del_sql,$affected_rows);
	}
}
}

public function send(){
$this->load->helper('helper');	
$this->load->database();
error_reporting(E_ALL & ~E_NOTICE& ~E_WARNING);
 $delay_seconds = rand(3,12);
 sleep($delay_seconds);
 echo $time_now = get_current_actual_dubai_time();
 $day = date("d" ,strtotime($time_now));
 $hour = date("G",strtotime($time_now));
 $minute = intval(date("i",strtotime($time_now)));
 $second = date("s",strtotime($time_now)); 
 
if(in_array($hour, array(2,4,9 )) and ($minute%23)==1){
$this->delete_sent_records();
}
if(in_array($hour, array(3,5,9)) and ($minute%21)==1){
$this->delete_downloaded_records();
}
if(in_array($hour, array(2,12,23)) and ($minute%27)==1){
$this->delete_unwanted_duplicate_block_logs();	
}
if(in_array($hour, array(7,11,16,22)) and ($minute%22)==1){
$this->delete_unwanted_cron_files_from_root();	
}
if(in_array($hour, array(12,17,19,6)) and ($minute%25)==1){
$this->block_expired_dead_lines();	
}
//if($minute%3 ==1 or $minute%3 ==2 ){
if($minute%2==1){	
echo	$info= "Skipping mail sending in odd minutes $minute ";
	if(in_array($hour,array(3,8,12,15,19,23))) log_data("mail_send_skip",$info);
	return false;
}else{
    if(in_array($hour,array(3,8,12,15,19,21))) log_data("mail_send_proceed",$info);	
echo $info= "Proceeding mail sending in even minutes $minute ";
$server_domain ="42mr-server5.com";
$time_now = get_current_actual_dubai_time();
$this->load->library('email');
$config['smtp_timeout']='30';
$this->email->initialize($config);
$this->email->set_newline("\r\n");
$country_id =$this->uri->segment(3);

$i=0;
$limit = mt_rand(35,50);
////
$sql = "SELECT count(id) as cnt FROM `hcp_email_queue` where (email_send_status is null)";
$query = $this->db->query($sql);
foreach ($query->result() as $row)
{ $count = $row->cnt;  }

if($count>4000){$limit = mt_rand(35,50); $range = "35 to 50"; 
}elseif($count>3500 and $count<=4000){$limit = mt_rand(30,45); $range = "30 to 45"; 
}elseif($count>3000 and $count<=3500){$limit = mt_rand(28,40); $range = "28 to 40"; 
}elseif($count>2500 and $count<=3000){$limit = mt_rand(26,38);  $range = "26 to 38"; 
}elseif($count>2000 and $count<=2500){$limit = mt_rand(24,36);  $range = "24 to 36"; 
}elseif($count>1500 and $count<=2000){$limit = mt_rand(23,35);  $range = "23 to 35"; 
}elseif($count>1000 and $count<=1500){$limit = mt_rand(22,33);  $range = "22 to 33"; 
}elseif($count>600 and $count<=1000){$limit = mt_rand(20,32);   $range = "20 to 32"; 
}elseif($count>300 and $count<=600){$limit = mt_rand(18,32);  $range = "18 to 32"; 
}elseif($count<=300){$limit = mt_rand(17,30);  $range = "17 to 30"; 
}
$limit = round($limit/2);
//echo $info ="Total remaining email count = $count. Range = $range . Picked limit = $limit ";
echo $info ="Total remaining email count = $count. Range = $range . Picked limit = $limit (divided by 2)";
log_data("mail_send",$info);
///// 
$sql = "SELECT * FROM `hcp_email_queue` where  country_name !='' and  (email_send_status is null) order by id limit 0,$limit"; 
echo $sql;
$query = $this->db->query($sql);
$row_count = $query->num_rows();
echo "<br>$row_count records found to send emails.";
if($row_count==0){
	echo "<br>No record found to send emails. So now trying to update country name if applicable";
	$this->update_country_name();
}

foreach ($query->result() as $row)
   {$i++;
	 $id = $row->id;
	 $hcp_id = $row->hcp_id;
	 $loi = $row->loi;
	 $incentive = $row->incentive;
	 $manager = $row->manager;
	 $currency = $row->currency;
	 $project_id = $row->project_id;
	 $project_name = $row->project_name;
	 $email = $row->email;
	 $subject = $row->subject;
	 $body_subject = $row->body_subject;
	 $email_address_assignment_id = $row->email_address_assignment_id;
	 $language_id = $row->language_id;
	 $template_id = $row->email_template;
	  
	 
	// if($i==1) $email ="shakilsustcse@gmail.com";
	// elseif($i==2) $email ="haque@42mr.com";
	// elseif($i==3) $email ="funkyzunky420@gmail.com";
	 
	 
	 // $language_id =$this->uri->segment(3);
	 
	 
	 //echo "<hr> subject :  ".$mail_subject = "Study - ".$project_name . " - $subject ";
	 
	 echo "<hr> subject :  ".$mail_subject = $this->TemplateModel->get_email_subject($template_id, $language_id, $project_name, $subject);
	 
	 
	  
	 $feedback_id = $row->feedback_id;
	 $title = $row->title;
	 $forename = $row->forename;
	 $surname = $row->surname;
	 $from_email = $row->from_email;
	 
	 
     $domain = substr($from_email, strpos($from_email, '@') + 1);
	 echo "<br><b>Sending Email =$from_email and Domain : $domain  </b><br>";
	 
	 //echo "<br>This server domain : ". $_SERVER['SERVER_NAME'];
	 //echo "<br>This server domain : ". $_SERVER['HTTP_HOST'];
	 
	 if($domain!=$server_domain){
	 $from_email = str_replace($domain,$server_domain,$from_email);
	  $domain = substr($from_email, strpos($from_email, '@') + 1);
	 echo "<br><b>New Sending Email =$from_email and Domain : $domain  </b><br>";
	 log_data("wrong_domain","$id - eid : $email_address_assignment_id  $domain $from_email",1);
	 }
	 
	 $mode= "Preview";
	 $msg =  $body=$this->emailer->prepare_email_from_data($row,$info,$mode);
	 
/*	 $msg = "Hi $title $forename  $surname,
	 We are conducting a study on $body_subject in France. We would like to invite you on the study. The study will not take more than $loi minutes and we'll pay you
	 $incentive $currency for your valuable time.
	 Kind Regards 
	 $manager
	 $time_now
	 42 Market research
	 JLT Dubai
	 United Arab Emirates
	 ";*/
	 // echo "<br><br> Message :  ". $msg;
	 echo $info = "<br><br>Send to $email  $hcp_id $forename $surname from $from_email ";
///////////////
$abuse_email = "abuse@$server_domain"; 
$this->email->from($from_email,$manager);
$this->email->to($email);
$this->email->subject($mail_subject);
$this->email->message($msg);
//$this->email->bcc('shakilsustcse@gmail.com');
$this->email->set_header('X-Feedback-ID',$feedback_id);
$this->email->set_header('List-Unsubscribe',"<mailto:$abuse_email?subject=Unsubscribe email assignment id $email_address_assignment_id >");
//$this->email->add_custom_header('X-Feedback-ID',$feedback_id);
// $this->email->_set_header('X-Feedback-ID',$feedback_id);	 
 
$result = $this->email->send();
 if($result==true){
	 $ids[] = $id;
	 echo "<br>Email was sent to $email successfully<br>";
	 log_data("mail_send_success","Success : $email  $hcp_id $forename $surname from $from_email",1);
	////////////// 
	$server_id=5;
	if( $this->emailer->bcc_track_with_server_id($project_name,$template_id,$server_id) ===0){
		$to_bcc = "interviews@42international.onmicrosoft.com";
		//$mail_subject = "Default Internal BCC ".$mail_subject;
		$this->email->to($to_bcc);
		$this->email->subject($mail_subject);
		$this->email->from($from_email,$manager);
		//$this->email->bcc('shakilsustcse@gmail.com');
        $this->email->message($msg);
        $this->email->set_header('X-Feedback-ID',$feedback_id);

		$result = $this->email->send();
		if($result==true){
		log_data("mail_send_bcc","BCC email sent to $to_bcc for $project_name ($project_id) - Template id : $template_id : hcp_id : $hcp_id - $email - $mail_subject",1);
		}
		
		$to_bcc ="interviews@fortytwo.serverdata.net";
		$this->email->to($to_bcc);
		$this->email->subject($mail_subject);
		$this->email->from($from_email,$manager);
		$this->email->message($msg);
        $this->email->set_header('X-Feedback-ID',$feedback_id);
		$result = $this->email->send();
		if($result==true){
		log_data("mail_send_bcc","BCC email sent to $to_bcc for $project_name ($project_id) - Template id : $template_id : hcp_id : $hcp_id - $email - $mail_subject",1);
		}else{
        log_data("mail_send_bcc","FAILED - BCC email failed to $to_bcc for $project_name ($project_id) - Template id : $template_id : hcp_id : $hcp_id - $email - $mail_subject",1);			
		}
		
		$to_bcc ="interviews@fastmail.com";
		$this->email->to($to_bcc);
		$this->email->subject($mail_subject);
		$this->email->from($from_email,$manager);
		$this->email->message($msg);
        $this->email->set_header('X-Feedback-ID',$feedback_id);
		$result = $this->email->send();
		if($result==true){
		log_data("mail_send_bcc","BCC email sent to $to_bcc for $project_name ($project_id) - Template id : $template_id : hcp_id : $hcp_id - $email - $mail_subject",1);
		}else{
        log_data("mail_send_bcc","FAILED - BCC email failed to $to_bcc for $project_name ($project_id) - Template id : $template_id : hcp_id : $hcp_id - $email - $mail_subject",1);			
		}
		 
	}
	 
	 
	////////////// 
	 
	 
	 
 }else {
	 $failed_ids[] = $id;
	 echo "<br>Email was not sent to $email <br>";
	 echo "<br><hr><br>Show debug messages : ". $messages = $this->email->print_debugger();
   $short_message = substr($messages,100,400);
   $extra = "email : $email, hcp_id : $hcp_id, email_address_assignment_id : $email_address_assignment_id, name : $forename $surname, from $from_email";
   log_data("mail_send_fail_new","Failed : $email  $hcp_id $forename $surname from $from_email $short_message",1);
   $this->save_failed_mails_detail($from_email,$email,$mail_subject,$messages,$extra);
 }
 echo $this->email->print_debugger();
 }
	
///////////////////
	 $all_ids = implode(",",$ids);
	 $sent_cnt = count($ids);
	 if($sent_cnt>0){
	 $update_sql="update hcp_email_queue set email_send_status=3,subject='',body_subject='',feedback_id='',project_name='',sent_date='$time_now',
     email=REPLACE (email, SUBSTR(email, 3, LENGTH(email)-3),'****'),
     forename=REPLACE (forename, SUBSTR(forename, 2, LENGTH(forename)-2),'****'),
     surname=REPLACE (surname, SUBSTR(surname,2, LENGTH(surname)-2),'****') 
	 where id IN($all_ids);";
	 
	 echo "<br><br>". $update_sql."<br><br>";
	 $this->db->query($update_sql);
	 $affected_rows = $this->db->affected_rows();
	 log_data("mail_send","row_count : $row_count sent_cnt : $sent_cnt limit in sql : $limit : sent_date='$time_now' where id IN($all_ids) affected_rows : $affected_rows",$affected_rows);
///////////////	
	echo "<br><br>". $insert_email_actions="insert into email_actions (`date`,imported_time,template_id,email_assignment_id,hcp_id,project_id,loi,incentive,currency,password,email,from_email) 
	select '$time_now',imported_time,email_template,email_address_assignment_id,hcp_id,project_id,loi,incentive,currency,password,email,from_email from hcp_email_queue where id IN($all_ids)";
	$this->db->query($insert_email_actions);
	$affected_rows = $this->db->affected_rows();
	log_data("mail_send"," insert_email_actions affected_rows : $affected_rows ",$affected_rows);
	 }
 	 
	 
	 if(is_array($failed_ids)) {
		 $failed_cnt = count($failed_ids);
		 if($failed_cnt>0){
			 $all_failed_ids = implode(",",$failed_ids);
			  $update_sql="update hcp_email_queue set email_send_status=4,subject='Failed to send',body_subject='',feedback_id='',project_name='',sent_date='$time_now',
     email=REPLACE (email, SUBSTR(email, 3, LENGTH(email)-3),'****'),
     forename=REPLACE (forename, SUBSTR(forename, 2, LENGTH(forename)-2),'****'),
     surname=REPLACE (surname, SUBSTR(surname,2, LENGTH(surname)-2),'****') 
	 where id IN($all_failed_ids);";
	 
	 echo "<br><br>". $update_sql."<br><br>";
	 $this->db->query($update_sql);
	 $affected_rows = $this->db->affected_rows();
	 log_data("mail_send_fail_update","row_count : $row_count failed_cnt : $failed_cnt limit in sql : $limit : sent_date='$time_now' where id IN($all_failed_ids) affected_rows : $affected_rows",$affected_rows);

		 }
	 }
	 
	 
///////////////		
if($row_count>0){	
$data = array('time' => $time_now,
        'all_count' => $count,
        'batch_size' => $limit,
		'sent_count' => $row_count);
$this->db->insert('sending_log', $data);
 $affected_rows = $this->db->affected_rows();
echo "<br> Inserted $affected_rows in sending_log with count : $count limit : $limit row count: $row_count ";	
}
///////////////
}
}	


public function delete_unwanted_cron_files_from_root() {
$dir    = '/home/mrserver5';
//$files1 = scandir($dir);
$files2 = scandir($dir, 1);
//print_r($files1);
//print_r($files2);
$i=0;
$info='';
foreach($files2 as $file){
	$path = $dir."/".$file;
	$initial = substr($file,0,5);
	if($i<1700 and is_file($path) and ($initial=='Send.' or $initial=='send.' )){
		$i++;
	//echo "<br> $initial ";
	echo "<br>$i You can delete $file $path";
	$info .="$file, ";
	 unlink($path);
	}
}
log_data("delete_unwanted_files"," $dir deleted files : $info");
}	



public function get_loi_data() {	
$this->load->database();
echo "received_data_".$data = $_REQUEST['data'];
$my_data = json_decode($data);
$date=date("d_m_y");
echo "Saving in : ". $file = "log/received_loi_data_".$date.".txt";
file_put_contents($file, $data);
$time_now = get_current_actual_dubai_time();
 echo "<pre>";
 print_r($my_data);
 $count = count($my_data);
 
foreach($my_data as $info){
	
	$project_id = $info->pid;
	$target_group = $info->tgp;
	$language_id = $info->ln_id;
	$hint = $info->hnt;
	$loi_incentive_text = $info->txt;
	
	$data = array(
			'project_id'   => $project_id ,
			'target_group'   => $target_group,
			'loi_incentive_text'   =>$loi_incentive_text,
			'hint'   => $hint,
			'language_id'   => $language_id) ;
	
	
	$where = array('project_id' => $project_id, 'target_group' => $target_group, 'language_id' => $language_id);
    $this->db->where($where); 
    $q = $this->db->get('loi_incentive_hints');
   if ( $q->num_rows() > 0 ) 
   {
	echo "<br>updating -> $project_id $target_group $language_id ->$loi_incentive_text";
	$this->db->where($where);
    $this->db->update('loi_incentive_hints',$data);
    $affected_rows = $this->db->affected_rows();
    log_data("loi_data_update", "updating -> $project_id $target_group $language_id ->$loi_incentive_text  \r\n Affected rows: $affected_rows \r\n ". __METHOD__ . " Line : " . __LINE__  ,$affected_rows);	
    }else{
	echo "<br>Inserting -> $project_id $target_group $language_id ->$loi_incentive_text";	
	$this->db->insert('loi_incentive_hints',$data);
	$affected_rows = $this->db->affected_rows();
	log_data("loi_data_update", "Inserting -> $project_id $target_group $language_id ->$loi_incentive_text  \r\n Affected rows: $affected_rows \r\n ". __METHOD__ . " Line : " . __LINE__ ,$affected_rows );	
    	
	}
}

}


//2021-05-03 - added by carl
public function remove_loi_data() {	
    
	$this->load->database();
	echo "received_data_".$data = $_REQUEST['data'];
	$my_data = json_decode($data);
	$date=date("d_m_y");
	echo "Saving in : ". $file = "log/received_loi_data_".$date.".txt";
	file_put_contents($file, $data);
	$time_now = get_current_actual_dubai_time();
	echo "<pre>";
	print_r($my_data);
	$count = count($my_data);
 
	foreach($my_data as $info){
	
		$project_id = $info->pid;
		$target_group = $info->tgp;
		$language_id = $info->ln_id;
		
		
		$where = array('project_id' => $project_id, 'target_group' => $target_group, 'language_id' => $language_id);
		$this->db->where($where); 
		$q = $this->db->get('loi_incentive_hints');
		
		if ( $q->num_rows() > 0 ) {
		
			$this->db->where('project_id', $project_id);
			$this->db->where('target_group', $target_group);
			$this->db->where('language_id', $language_id);
			$this->db->delete('loi_incentive_hints');
			$affected_rows_del = $this->db->affected_rows();			
			
			log_data("loi_data_update", "Deleting -> project_id: $project_id target_group: $target_group | language_id: $language_id  \r\n Affected rows: $affected_rows_del \r\n ". __METHOD__ . " Line : " . __LINE__ ,$affected_rows_del);
			
		}
	}

}	

public function block_expired_dead_lines(){	
$this->load->database();
$sql="SELECT distinct dead_line FROM `hcp_email_queue`  where email_send_status is null";
$query = $this->db->query($sql);
$today = date("d-m-Y");
$time_now = time();
foreach ($query->result() as $row)
   { 
	 echo "<br>".$dead_line = $row->dead_line;
	$dead_line_time = strtotime($dead_line);
	if( ($time_now - $dead_line_time) >0 ){ 
	echo " - Expired already.";

   echo "<br>".$sql="SELECT count(id) as cnt FROM `hcp_email_queue`  where email_send_status is null and dead_line='$dead_line'";
  $query2 = $this->db->query($sql);
   foreach ($query2->result() as $row2)
   { 
	 echo "<br>Total : ".$cnt = $row2->cnt;
   }
  $update_sql="update `hcp_email_queue` set email_send_status=4,subject='Failed to send',body_subject='',comment2='made failed for deadline expired' where email_send_status is null and dead_line='$dead_line'";
  $this->db->query($update_sql);
  $affected_rows = $this->db->affected_rows();
  log_data("expired_dead_lines","found count = $cnt updated count : $affected_rows ".$update_sql,$affected_rows);
  }
  else echo " - Still valid dead line.";
  }
}	
public function get_batch_data() {	
$this->load->database();
echo "received_data_".$data = $_REQUEST['data'];
$my_data = json_decode($data);
$date=date("d_m_y");
echo "Saving in : ". $file = "log/received_data_".$date.".txt";
file_put_contents($file, $data);
$time_now = get_current_actual_dubai_time();
 echo "<pre>";
 print_r($my_data);
 $count = count($my_data);
if($count>0){ 
foreach($my_data as $hcp_info){
	$comment = $hcp_info->pi ."_".$hcp_info->eid ."_".$hcp_info->tmplt . "_" . round($hcp_info->inc);
	$comment = $hcp_info->pi ."_".$hcp_info->eid ."_".$hcp_info->p;
	$data = array(
			'jupiter_id'   => $hcp_info->id,
			'hcp_id'   => $hcp_info->hcp_id,
			'title'      => $hcp_info->t,
			'target_group'  => $hcp_info->tg,
			'forename'      => $hcp_info->fn,
			'surname'      => $hcp_info->sn,
			'email'      => $hcp_info->e,
			'dead_line'      => $hcp_info->d,
			'from_email'      =>$hcp_info->fe,
			'email_id'  => $hcp_info->ei,
			'email_address_assignment_id'=> $hcp_info->eid,
			'password'=> $hcp_info->p,
			'gender'=> $hcp_info->g,
			'loi'=> $hcp_info->loi,
			'incentive'=> $hcp_info->inc,
			'initial_incentive'=> $hcp_info->ii,
			'project_id'   => $hcp_info->pi,
			'project_name' => $hcp_info->pn,
			'subject'      => $hcp_info->s, 
			'body_subject' =>$hcp_info->bs, 
			'manager'      => $hcp_info->m, 
			'country'      => $hcp_info->c, 
			'country_code' => $hcp_info->cc, 
			'language_id'  => $hcp_info->li,
			'customized_link' => $hcp_info->cl,
			'link'            => $hcp_info->l,
			'hint'            => $hcp_info->h,
			'currency'        => $hcp_info->cr,
			'feedback_id'  => $hcp_info->fi,
			'email_template'  => $hcp_info->tmplt,
			'comment'  => $comment,
			'imported_time' => $time_now
		);
		$project_name = $data['project_name'];
		$project_id = $data['project_id'];
		$country_id = $data['country'];
		 
		
		//if(strlen($invalid_emails)>4) $tracker_info .= "<br>$hcp_id : $name : $invalid_emails ";
 	 $this->db->insert('hcp_email_queue', $data);
	
	
}
}
  if($count>0){
	  $information = "$count records received from $project_name($project_id) country_id = $country_id";
	  log_data("data_received", "$information" ,$count);	
  } 
$data = array('time'   => $time_now,
			'received_count'   =>$count,
			'comment'   =>"$project_name($project_id)"
			);
$this->db->insert('receiving_log', $data);
  

$this->get_duplicates(); 
}
	

public function get_duplicates() {
	$this->load->database();
	
	echo "<br>Time now : ".$time_now = get_current_actual_dubai_time();
	
	echo "<br>Two hours ago  : ".$two_hours_ago = $date = date('Y-m-d H:i:s', strtotime($time_now)- 2*3600);
	$ids= $tokens=  array();
	  $sql = "SELECT comment, count(comment) as cnt FROM `hcp_email_queue` 
	where comment !='' and (email_send_status is null or email_send_status!=4) and imported_time>'$two_hours_ago' group by comment having cnt>1 order by cnt desc";
	echo $sql = "SELECT comment, count(comment) as cnt FROM `hcp_email_queue` 
	where comment !='' and (email_send_status is null)  group by comment having cnt>1 order by cnt desc";
	echo "<br>";
   $query = $this->db->query($sql);
$content = "<table class='table table-condensed table-bordered table-striped table-sm'>";
$i=0;
foreach ($query->result() as $row)
   { $i++;
   $comment = trim($row->comment);
   $tokens[] = $comment;
   $cnt =    $row->cnt;
	$content .="<tr class=''><td >$comment  - $cnt</td></tr>";  	
   }
   
   $count = count($tokens);
   
  log_data("duplicate_block","Total duplicate = $count"); 
   
   echo "<br>Total duplicate = $count";
  // if($i>0) echo $content .= "</table>";	
if($count>0){
	$all_tokens = implode("','",$tokens);
	echo $sql = "SELECT * FROM `hcp_email_queue` where comment IN('$all_tokens') order by comment ,id desc";
	$query = $this->db->query($sql);
	$prev_criteria = $criteria='';
   foreach ($query->result() as $row)
   {  
   $id =  $row->id;
   $jupiter_id =  $row->jupiter_id;
   $email_send_status =  $row->email_send_status;
   $criteria = $comment = trim($row->comment);
   if($prev_criteria == $criteria){
   echo "<br>jupiter_id - $jupiter_id  status : $email_send_status  - $comment : Mark $id not to send  ";
   if($email_send_status ==''){
	   $ids[] = $id;
   }
   
   }else{
	   echo "<br>jupiter_id - $jupiter_id  status : $email_send_status  - $comment :  $id Okay to send";
   }
   
   $prev_criteria = $criteria;
   
   }
   
   if(count($ids)>0){
	   $all_ids = implode(",",$ids);
	   $update_sql="update `hcp_email_queue` set email_send_status = 9, comment2='duplicate blocked' where id IN($all_ids)";
	    $this->db->query($update_sql);
		log_data("duplicate_block",$update_sql);
   }
}
} //function ends  

	
	
}
